Fastest possible string key lookup for known set of keys
Asked Answered
B

8

16

Consider a lookup function with the following signature, which needs to return an integer for a given string key:

int GetValue(string key) { ... }

Consider furthermore that the key-value mappings, numbering N, are known in advance when the source code for function is being written, e.g.:

// N=3
{ "foo", 1 },
{ "bar", 42 },
{ "bazz", 314159 }

So a valid (but not perfect!) implementation for the function for the input above would be:

int GetValue(string key)
{
    switch (key)
    {
         case "foo": return 1;
         case "bar": return 42;
         case "bazz": return 314159;
    }

    // Doesn't matter what we do here, control will never come to this point
    throw new Exception();
}

It is also known in advance exactly how many times (C>=1) the function will be called at run-time for every given key. For example:

C["foo"] = 1;
C["bar"] = 1;
C["bazz"] = 2;

The order of such calls is not known, however. E.g. the above could describe the following sequence of calls at run-time:

GetValue("foo");
GetValue("bazz");
GetValue("bar");
GetValue("bazz");

or any other sequence, provided the call counts match.

There is also a restriction M, specified in whatever units is most convenient, defining the upper memory bound of any lookup tables and other helper structures that can be used by the GetValue (the structures are initialized in advance; that initialization is not counted against the complexity of the function). For example, M=100 chars, or M=256 sizeof(object reference).

The question is, how to write the body of GetValue such that it is as fast as possible - in other words, the aggregate time of all GetValue calls (note that we know the total count, per everything above) is minimal, for given N, C and M?

The algorithm may require a reasonable minimal value for M, e.g. M >= char.MaxValue. It may also require that M be aligned to some reasonable boundary - for example, that it may only be a power of two. It may also require that M must be a function of N of a certain kind (for example, it may allow valid M=N, or M=2N, ...; or valid M=N, or M=N^2, ...; etc).

The algorithm can be expressed in any suitable language or other form. For runtime performance constrains for generated code, assume that the generated code for GetValue will be in C#, VB or Java (really, any language will do, so long as strings are treated as immutable arrays of characters - i.e. O(1) length and O(1) indexing, and no other data computed for them in advance). Also, to simplify this a bit, answers which assume that C=1 for all keys are considered valid, though those answers which cover the more general case are preferred.

Some musings on possible approaches

The obvious first answer to the above is using a perfect hash, but generic approaches to finding one seem to be imperfect. For example, one can easily generate a table for a minimal perfect hash using Pearson hashing for the sample data above, but then the input key would have to be hashed for every call to GetValue, and Pearson hash necessarily scans the entire input string. But all sample keys actually differ in their third character, so only that can be used as the input for the hash instead of the entire string. Furthermore, if M is required to be at least char.MaxValue, then the third character itself becomes a perfect hash.

For a different set of keys this may no longer be true, but it may still be possible to reduce the amount of characters considered before the precise answer can be given. Furthermore, in some cases where a minimal perfect hash would require inspecting the entire string, it may be possible to reduce the lookup to a subset, or otherwise make it faster (e.g. a less complex hashing function?) by making the hash non-minimal (i.e. M > N) - effectively sacrificing space for the sake of speed.

It may also be that traditional hashing is not such a good idea to begin with, and it's easier to structure the body of GetValue as a series of conditionals, arranged such that the first checks for the "most variable" character (the one that varies across most keys), with further nested checks as needed to determine the correct answer. Note that "variance" here can be influenced by the number of times each key is going to be looked up (C). Furthermore, it is not always readily obvious what the best structure of branches should be - it may be, for example, that the "most variable" character only lets you distinguish 10 keys out of 100, but for the remaining 90 that one extra check is unnecessary to distinguish between them, and on average (considering C) there are more checks per key than in a different solution which does not start with the "most variable" character. The goal then is to determine the perfect sequence of checks.

Barber answered 16/7, 2011 at 1:41 Comment(0)
C
4

You could use the Boyer search, but I think that the Trie would be a much more effiecent method. You can modify the Trie to collapse the words as you make the hit count for a key zero, thus reducing the number of searches you would have to do the farther down the line you get. The biggest benefit you would get is that you are doing array lookups for the indexes, which is much faster than a comparison.

Canara answered 16/7, 2011 at 2:49 Comment(4)
A very interesting take. I have considered that even better optimization might be possible by employing some mutable helper data structure, but couldn't come up with a specific example. However, I think that it can be done better than a simple trie - most notably, tries are normally constructed in order in which characters appear in the keys; but given a known set of keys, it should be possible to come up with a different order that is more efficient.Barber
I like culling the trie to take advantage of known occurrence counts, +1. A dynamic method may be fast but would it be worth recreating to remove keys you know aren't going to show up again?Caucasoid
@Pavel: Your implementation of the Trie can organize each prefix according to the statistical likelihood that prefix will occur, e.g. if the most common first letter is 'c', ensure that 'c' is checked before checking other initial characters from other words.Feriga
The benefit of the tri, is that the lookup is at most O(n) where n is the number of chars in the key, as opposed to the number of entries in data structure. This works well for dictionaries with a relatively small key size compared to the size of the dictionary.Canara
P
4

You've talked about a memory limitation when it comes to precomputation - is there also a time limitation?

I would consider a trie, but one where you didn't necessarily start with the first character. Instead, find the index which will cut down the search space most, and consider that first. So in your sample case ("foo", "bar", "bazz") you'd take the third character, which would immediately tell you which string it was. (If we know we'll always be given one of the input words, we can return as soon as we've found a unique potential match.)

Now assuming that there isn't a single index which will get you down to a unique string, you need to determine the character to look at after that. In theory you precompute the trie to work out for each branch what the optimal character to look at next is (e.g. "if the third character was 'a', we need to look at the second character next; if it was 'o' we need to look at the first character next) but that potentially takes a lot more time and space. On the other hand, it could save a lot of time - because having gone down one character, each of the branches may have an index to pick which will uniquely identify the final string, but be a different index each time. The amount of space required by this approach would depend on how similar the strings were, and might be hard to predict in advance. It would be nice to be able to dynamically do this for all the trie nodes you can, but then when you find you're running out of construction space, determine a single order for "everything under this node". (So you don't end up storing a "next character index" on each node underneath that node, just the single sequence.) Let me know if this isn't clear, and I can try to elaborate...

How you represent the trie will depend on the range of input characters. If they're all in the range 'a'-'z' then a simple array would be incredibly fast to navigate, and reasonably efficient for trie nodes where there are possibilities for most of the available options. Later on, when there are only two or three possible branches, that becomes wasteful in memory. I would suggest a polymorphic Trie node class, such that you can build the most appropriate type of node depending on how many sub-branches there are.

None of this performs any culling - it's not clear how much can be achieved by culling quickly. One situation where I can see it helping is when the number of branches from one trie node drops to 1 (because of the removal of a branch which is exhausted), that branch can be eliminated completely. Over time this could make a big difference, and shouldn't be too hard to compute. Basically as you build the trie you can predict how many times each branch will be taken, and as you navigate the trie you can subtract one from that count per branch when you navigate it.

That's all I've come up with so far, and it's not exactly a full implementation - but I hope it helps...

Postdate answered 29/7, 2011 at 20:5 Comment(7)
There's no hard time limitation on precomputing the tables other than "reasonable" (i.e. I understand that you could always brute force the perfect arrangement, in 10^somthing years :)Barber
The general approach with "reordered trie" is straightforward, but the hard question is how to figure out the optimal character index on each step. The obvious answer is to take the one that differs most across words, and then go in decreasing order of that; but I'm not convinced that it is actually the optimal choice for all inputs.Barber
Also, one possible representation of a particular step in this trie would be just a bunch of if-else statements - remember that we're generating code here, and it doesn't have to be just the initialization part - the lookup function itself can also be partly or wholly generated. I suspect that for cases with 2-3 options, if/else may actually be faster than array lookup due to boundary checks (in Java/.NET) and indirection.Barber
@Pavel: The choice of character would depend on whether you wanted to decrease the average time, the best time, or the worst time, I guess. I suspect it would be reasonable to pick the index which minimizes the maximum number of words left in each branch. As for the if/else - that's what I meant by the polymorphic nodes. You'd have one class representing a node with only two choices, one for a node with only three choices, and one for "more than three" - or something like that.Postdate
I'm not saying this is absolutely optimal by the way - but I suspect it would be blisteringly fast, particularly in the case where at each node you get to decide which character to look at next.Postdate
But there's no need for classes or polymorphism here, since we know in advance which branch leads to which - just hardcode it all. As for perf, sure, this is already way beyond any pragmatic territory - in practice, even a normal trie is "fast enough" - but where's the fun in that? ~Barber
@Pavel: Oh, I see what you mean about hardcoding. All within a giant if block per node. The downside of that is that you won't be able to do branch collapsing (i.e. when there's only one branch down, coalesce the two nodes). I suspect this would really be insanely fast. If you have a sample data set, it would be interesting to try various options...Postdate
C
1

Is a binary search of the table really so awful? I would take the list of potential strings and "minimize" them, the sort them, and finally do a binary search upon the block of them.

By minimize I mean reducing them to the minimum they need to be, kind of a custom stemming.

For example if you had the strings: "alfred", "bob", "bill", "joe", I'd knock them down to "a", "bi", "bo", "j".

Then put those in to a contiguous block of memory, for example:

char *table = "a\0bi\0bo\0j\0"; // last 0 is really redundant..but
char *keys[4];
keys[0] = table;
keys[1] = table + 2;
keys[2] = table + 5;
keys[3] = table + 8;

Ideally the compiler would do all this for you if you simply go:

keys[0] = "a";
keys[1] = "bi";
keys[2] = "bo";
keys[3] = "j";

But I can't say if that's true or not.

Now you can bsearch that table, and the keys are as short as possible. If you hit the end of the key, you match. If not, then follow the standard bsearch algorithm.

The goal is to get all of the data close together and keep the code itty bitty so that it all fits in to the CPU cache. You can process the key from the program directly, no pre-processing or adding anything up.

For a reasonably large number of keys that are reasonably distributed, I think this would be quite fast. It really depends on the number of strings involved. For smaller numbers, the overhead of computing hash values etc is more than search something like this. For larger values, it's worth it. Just what those number are all depends on the algorithms etc.

This, however, is likely the smallest solution in terms of memory, if that's important.

This also has the benefit of simplicity.

Addenda:

You don't have any specifications on the inputs beyond 'strings'. There's also no discussion about how many strings you expect to use, their length, their commonality or their frequency of use. These can perhaps all be derived from the "source", but not planned upon by the algorithm designer. You're asking for an algorithm that creates something like this:

inline int GetValue(char *key) {
    return 1234;
}

For a small program that happens to use only one key all the time, all the way up to something that creates a perfect hash algorithm for millions of strings. That's a pretty tall order.

Any design going after "squeezing every single bit of performance possible" needs to know more about the inputs than "any and all strings". That problem space is simply too large if you want it the fastest possible for any condition.

An algorithm that handles strings with extremely long identical prefixes might be quite different than one that works on completely random strings. The algorithm could say "if the key starts with "a", skip the next 100 chars, since they're all a's".

But if these strings are sourced by human beings, and they're using long strings of the same letters, and not going insane trying to maintain that data, then when they complain that the algorithm is performing badly, you reply that "you're doing silly things, don't do that". But we don't know the source of these strings either.

So, you need to pick a problem space to target the algorithm. We have all sorts of algorithms that ostensibly do the same thing because they address different constraints and work better in different situations.

Hashing is expensive, laying out hashmaps is expensive. If there's not enough data involved, there are better techniques than hashing. If you have large memory budget, you could make an enormous state machine, based upon N states per node (N being your character set size -- which you don't specify -- BAUDOT? 7-bit ASCII? UTF-32?). That will run very quickly, unless the amount of memory consumed by the states smashes the CPU cache or squeezes out other things.

You could possibly generate code for all of this, but you may run in to code size limits (you don't say what language either -- Java has a 64K method byte code limit for example).

But you don't specify any of these constraints. So, it's kind of hard to get the most performant solution for your needs.

Crumpler answered 16/7, 2011 at 5:13 Comment(4)
Note that this is specifically a question about squeezing every single bit of performance possible, at the expense of memory (within specified bounds). Presorted array is very likely the most efficient structure for this memory-wise, but perf-wise it's so-so (compared to other possible options). Also, for your specific approach, consider what happens when input keys have long identical initial sequences.Barber
Regarding your addendum. Yes, this is a meta-question that is intentionally broad. I know about many algorithms tailored to specific input sets - the question here is to make an algorithm to pick an algorithm so to speak, by analyzing one particular potential input set. So, for example, if the input set has a lot of strings with identical prefixes, then the algorithm desired would produce code that implements an algorithm that is optimal for that kind of thing. My more broad hope is that it would be possible to cover all this by a single parametrized algorithm, and vary the parameters.Barber
Character set is UTF-16 (as in Java/.NET strings). Let's disregard code size limitations for the time being (I can certainly split generated code if need be).Barber
Also, "laying hashmaps is expensive" - note that in this case, since the entire set of keys is known in advance, hashmap (i.e. buckets and their content) can be generated at compile time, spitting out premade buckets as simple initialized arrays. In any case, the question explicitly specifies that advance initialization of data structures is not counted here, only actual lookup. So if there is some magic parametrized hash function that satisfies other constraints, I'll be glad to hear about it.Barber
C
0

Here's a feasible approach to determine the smallest subset of chars to target for your hash routine:

let:
k be the amount of distinct chars across all your keywords
c be the max keyword length
n be the number of keywords
in your example (padded shorter keywords w/spaces):

"foo "
"bar "
"bazz"

k = 7 (f,o,b,a,r,z, ), c = 4, n = 3

We can use this to compute a lower bound for our search. We need at least log_k(n) chars to uniquely identify a keyword, if log_k(n) >= c then you'll need to use the whole keyword and there's no reason to proceed.

Next, eliminate one column at a time and check if there are still n distinct values remaining. Use the distinct chars in each column as a heuristic to optimize our search:

2 2 3 2
f o o .
b a r .
b a z z

Eliminate columns with the lowest distinct chars first. If you have <= log_k(n) columns remaining you can stop. Optionally you could randomize a bit and eliminate the 2nd lowest distinct col or try to recover if the eliminated col results in less than n distinct words. This algorithm is roughly O(n!) depending on how much you try to recover. It's not guaranteed to find an optimal solution but it's a good tradeoff.

Once you have your subset of chars, proceed with the usual routines for generating a perfect hash. The result should be an optimal perfect hash.

Caucasoid answered 16/7, 2011 at 2:51 Comment(5)
The use of DynamicMethod here is not really important - as it happens, the practical task for which this would be applied already involves code generation, so when I wrote "compile time" I meant literally just that. The catch is figuring out the perfect sequence - which columns to look up first. I don't think it's as simple as picking columns in the order of reduced variability, though. But if I'm wrong, and there is a formal proof that it is so, that would be the ultimate answer.Barber
Ah, so you're really after a minimal perfect hash. I edited my answer and added a linkCaucasoid
No, not necessarily a minimal perfect hash. A minimal perfect hash is focused on memory efficiency - it is about making the lookup table as small as possible. This is not the goal here - you can blow the table up all the way to M, leaving unused gaps in it, so long as doing so will give you better performance. If a faster hash maps three keys to 1, 10, 100, it's better for the purpose of this question than a slower one that maps them to 1, 2, 3.Barber
As well, a regular perfect hash is not constant time - it's (at least for algorithms that I know of) O(N) of the size of input key, since you need to hash the input to match against the table. Given that we know the keys, at the very least, it is possible to devise a more efficient hash by only considering those columns that differ, rather than hashing the entire string.Barber
^Better approach for finding optimal subset of charsCaucasoid
F
0

What you want is a look-up table of look-up tables. If memory cost is not an issue you can go all out.

const int POSSIBLE_CHARCODES = 256; //256 for ascii //65536 for unicode 16bit
struct LutMap {
    int value;
    LutMap[POSSIBLE_CHARCODES] next;
}
int GetValue(string key) {
    LutMap root = Global.AlreadyCreatedLutMap;
    for(int x=0; x<key.length; x++) {
        int c = key.charCodeAt(x);
        if(root.next[c] == null) {
            return root.value;
        }
        root = root.next[c];
    }
}
Footstep answered 28/7, 2011 at 18:2 Comment(1)
Memory cost is an issue, hence why there is the upper memory boundary M. Your solution can be adapted to adhere to it by bucketing together chars on, say, the lower N bits, so that we use less memory at the expense of perf (having to do linear search per bucket). The trick however is to figure out how to arrange the buckets to minimize the number of linear searches.Barber
H
0

I reckon that it's all about finding the right hash function. As long as you know what the key-value relationship is in advance, you can do an analysis to try and find a hash function to meet your requrements. Taking the example you've provided, treat the input strings as binary integers:

foo  = 0x666F6F (hex value)
bar  = 0x626172
bazz = 0x62617A7A

The last column present in all of them is different in each. Analyse further:

foo  = 0xF = 1111
bar  = 0x2 = 0010
bazz = 0xA = 1010

Bit-shift to the right twice, discarding overflow, you get a distinct value for each of them:

foo  = 0011
bar  = 0000
bazz = 0010

Bit-shift to the right twice again, adding the overflow to a new buffer: foo = 0010 bar = 0000 bazz = 0001

You can use those to query a static 3-entry lookup table. I reckon this highly personal hash function would take 9 very basic operations to get the nibble (2), bit-shift (2), bit-shift and add (4) and query (1), and a lot of these operations can be compressed further through clever assembly usage. This might well be faster than taking run-time infomation into account.

Hosiery answered 30/7, 2011 at 0:15 Comment(0)
L
0

Have you looked at TCB . Perhaps the algorithm used there can be used to retrieve your values. It sounds a lot like the problem you are trying to solve. And from experience I can say tcb is one of the fastest key store lookups I have used. It is a constant lookup time, regardless of the number of keys stored.

Lepidopterous answered 30/7, 2011 at 7:18 Comment(0)
U
0

Consider using Knuth–Morris–Pratt algorithm.

Pre-process given map to a large string like below

String string = "{foo:1}{bar:42}{bazz:314159}";
int length = string.length();

According KMP preprocessing time for the string will take O(length). For searching with any word/key will take O(w) complexity, where w is length of the word/key.

You will be needed to make 2 modification to KMP algorithm:

  • key should be appear ordered in the joined string
  • instead of returning true/false it should parse the number and return it

Wish it can give a good hints.

Unrobe answered 31/7, 2011 at 20:18 Comment(0)

© 2022 - 2024 — McMap. All rights reserved.